/*
FILE
	$Id: mysqlrad.h,v 1.15 2003/11/13 20:44:21 ggw Exp $
	ism|3 mysqlRAD2 generated include file for mysqlBind.cgi
	(tAuthorize.cPasswd template set member)
AUTHOR
	Template and mysqlRAD2 author: (c) 2001,2002 Gary Wallis. 
	GPL license applies: See www.fsf.org
*/

#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>
#include <signal.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#ifndef Linux
        #include <sys/systeminfo.h>
#else
        #ifndef FreeBSD
                #include <crypt.h>
        #endif
#endif
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <string.h>
#include <sys/file.h>

#include "cgi.h"

#ifdef FreeBSD
	#include "/usr/local/include/mysql/mysql.h"
#else
	#include <mysql/mysql.h>
#endif


#include <unistd.h>

#include "language.h"
#include "local.h"

extern char cHost[];
extern char cHostname[];
extern char cUser[];
#define PERMLEVEL
extern int uPermLevel; 
extern unsigned uLoginClient; 
extern unsigned uReseller; 

extern char function[];
extern char query[];
extern char *qstr;
extern MYSQL mysql; 
extern unsigned long rowid;
extern unsigned start;
extern unsigned end;
extern unsigned i;
extern unsigned n;
extern char command[];
extern char filter[];
extern char find[];
extern char table[];
extern int mode;
extern int error;
extern char errormsg[];

void mysqlBind(char *result);
void ConnectDb(void);
void Footer_ism3(void);
void Header_ism3(char *msg, int js);
void ProcessControlVars(pentry entries[], int x);
void OpenRow(char *cFieldLabel, char *cColor);
void LoadConf(void);
void NoSuchFunction(void);
void tTablePullDownOwner(char *cTableName, char *cFieldName,
                        char *cOrderby, int unsigned uSelector);
void tTablePullDown(char *cTableName, char *cFieldName,
                        char *cOrderby, int unsigned uSelector);
void tTablePullDownReadOnly(char *cTableName, char *cFieldName,
                        char *cOrderby, int unsigned uSelector);
int ReadPullDown(char *cTableName,char *cFieldName,char *cLabel);
char *TextAreaSave(char *cField);
char *TransformAngleBrackets(char *cField);
char *EncodeDoubleQuotes(char *cField);
void YesNoPullDown(char *cFieldName, unsigned uSelect);
void YesNo(unsigned uSelect);
int ReadYesNoPullDown(char *cLabel);
char *ForeignKey(char *cTableName, char *cFieldName, unsigned uKey);
void GetClientOwner(unsigned uClient, unsigned *uOwner);

 //Standard tInputFunc functions
char *WordToLower(char *cInput);
char *IPNumber(char *cInput);
char *FQDomainName(char *cInput);
char *EmailInput(char *cInput);

 //Standard tValidFunc functions
char *EmptyString(char *cInput);
char *BadIPNum(char *cInput);
char *IsZero(unsigned uInput);

 //External pagination form processing vars
void PageMachine(char *funcName, int mode, char *msg);

 //Place ModuleCommands() and Module() prototypes here
#define ISPNAME "OpenISP"
#define ISPURL "www.openisp.net"
#define ADMIN 9

 //Native MySQL fields
#define COLTYPE_INTUNSIGNED 3
#define COLTYPE_TIMESTAMP 7
#define COLTYPE_DATETIME 12
#define COLTYPE_CHAR 254
#define COLTYPE_VARCHAR 253
#define COLTYPE_TEXT 252

 //Our special gui fields
#define COLTYPE_SELECTTABLE 1000
#define COLTYPE_RADPRI 1001
#define COLTYPE_PRIKEY 1002
#define COLTYPE_YESNO 1003
#define COLTYPE_UNIXTIMECREATE 1004
#define COLTYPE_UNIXTIMEUPDATE 1005
#define COLTYPE_EXTFUNC 1006
#define COLTYPE_FOREIGNKEY 1007
#define COLTYPE_UINTUKEY 1008
#define COLTYPE_VARCHARUKEY 1009

 //builder.c
void ProcessBuilderVars(pentry entries[], int x);
int BuilderCommands(pentry entries[], int x);
void ProjectTablesPullDown(unsigned uProjId);
void ProjectsPullDown(void);
unsigned int GetProjId(char *cProject);
void SQLCreatePart(char *qstr, char *cFieldName,
                char *cFieldSize, unsigned int uFieldType);
void UpdateAppSchema(void);
void BuilderCreate(char *table, int mode, FILE *fp, char *Module, unsigned uProjId);
char *TransFieldType(unsigned int type);
unsigned int SelectuTablid(char *cTable, unsigned uProjId);

 //makesource.c
int TableNameSelect(char *cProjectName);
char *GetTableKey(char *cTableName);
void ModuleVars(FILE *ofp);
void ModuleProcVars(FILE *fp);
void ModuleLoadVars(FILE *fp);
void ModuleVarList(FILE *fp);
void ModuleContent(FILE *fp);
void ModuleInsertQuery(FILE *fp);
void ModuleUpdateQuery(FILE *fp);
void ModuleListPrint(FILE *fp);
void ModuleListTable(FILE *fp);
void MakeProjectModuleFiles(char *cName);
void MakeProjectMainFile(char *cName);
char *ConvertToLowerCase(char *inputstr);
void MakeProjectMakefile(char *cName);
void MakeProjectIncludeFile(char *cName);
void MakeProjectTableSourceFiles(char *cName);
void ObjectList(FILE *ofp );
void ModuleRuleList(FILE *ofp);
void ModulePrototypes(FILE *ofp);
void ModuleMainGetMenu(FILE *ofp);
void ModuleMenuItems(FILE *ofp);
void ModulePostFunctions(FILE *ofp);
int FieldNameSelect(char *cTableName);
void ModuleCreateQuery(FILE *fp);



 //MakeTableSource prototypes
//tZone
int tZoneCommands(pentry entries[], int x);
void tZone(char *results);
void ProcesstZoneVars(pentry entries[], int x);
void tZoneContent(void);
void tZoneInputContent(void);
void tZoneList(void);
void NewtZone(unsigned uMode);
void ModtZone(void);
void CreatetZone(void);
void DeletetZone(void);
void ExttZoneGetHook(entry gentries[], int x);

//tResource
int tResourceCommands(pentry entries[], int x);
void tResource(char *results);
void ProcesstResourceVars(pentry entries[], int x);
void tResourceContent(void);
void tResourceInputContent(void);
void tResourceList(void);
void NewtResource(unsigned uMode);
void ModtResource(void);
void CreatetResource(void);
void DeletetResource(void);
void ExttResourceGetHook(entry gentries[], int x);

//tRRType
int tRRTypeCommands(pentry entries[], int x);
void tRRType(char *results);
void ProcesstRRTypeVars(pentry entries[], int x);
void tRRTypeContent(void);
void tRRTypeInputContent(void);
void tRRTypeList(void);
void NewtRRType(unsigned uMode);
void ModtRRType(void);
void CreatetRRType(void);
void DeletetRRType(void);
void ExttRRTypeGetHook(entry gentries[], int x);

//tJob
int tJobCommands(pentry entries[], int x);
void tJob(char *results);
void ProcesstJobVars(pentry entries[], int x);
void tJobContent(void);
void tJobInputContent(void);
void tJobList(void);
void NewtJob(unsigned uMode);
void ModtJob(void);
void CreatetJob(void);
void DeletetJob(void);
void ExttJobGetHook(entry gentries[], int x);

//tNameServer
int tNameServerCommands(pentry entries[], int x);
void tNameServer(char *results);
void ProcesstNameServerVars(pentry entries[], int x);
void tNameServerContent(void);
void tNameServerInputContent(void);
void tNameServerList(void);
void NewtNameServer(unsigned uMode);
void ModtNameServer(void);
void CreatetNameServer(void);
void DeletetNameServer(void);
void ExttNameServerGetHook(entry gentries[], int x);

//tMailServer
int tMailServerCommands(pentry entries[], int x);
void tMailServer(char *results);
void ProcesstMailServerVars(pentry entries[], int x);
void tMailServerContent(void);
void tMailServerInputContent(void);
void tMailServerList(void);
void NewtMailServer(unsigned uMode);
void ModtMailServer(void);
void CreatetMailServer(void);
void DeletetMailServer(void);
void ExttMailServerGetHook(entry gentries[], int x);

//tConfiguration
int tConfigurationCommands(pentry entries[], int x);
void tConfiguration(char *results);
void ProcesstConfigurationVars(pentry entries[], int x);
void tConfigurationContent(void);
void tConfigurationInputContent(void);
void tConfigurationList(void);
void NewtConfiguration(unsigned uMode);
void ModtConfiguration(void);
void CreatetConfiguration(void);
void DeletetConfiguration(void);
void ExttConfigurationGetHook(entry gentries[], int x);

//tClient
int tClientCommands(pentry entries[], int x);
void tClient(char *results);
void ProcesstClientVars(pentry entries[], int x);
void tClientContent(void);
void tClientInputContent(void);
void tClientList(void);
void NewtClient(unsigned uMode);
void ModtClient(void);
void CreatetClient(void);
void DeletetClient(void);
void ExttClientGetHook(entry gentries[], int x);

//tAuthorize
int tAuthorizeCommands(pentry entries[], int x);
void tAuthorize(char *results);
void ProcesstAuthorizeVars(pentry entries[], int x);
void tAuthorizeContent(void);
void tAuthorizeInputContent(void);
void tAuthorizeList(void);
void NewtAuthorize(unsigned uMode);
void ModtAuthorize(void);
void CreatetAuthorize(void);
void DeletetAuthorize(void);
void ExttAuthorizeGetHook(entry gentries[], int x);


