/*
FILE
	$Id: tclientfunc.h,v 1.9 2003/11/13 21:12:02 ggw Exp $
	(tAuthorize.cPasswd template set member)
PURPOSE

AUTHOR
	Template and mysqlRAD2 author: (c) 2001,2002,2003,2004 Gary Wallis.
	GPL License applies, see www.fsf.org for details

 
*/

static char cPasswd[16]={""};
static char cExtLabel[16]={""};
static char cuPerm[33]={""};
static unsigned uPerm=0;

//Aux drop/pull downs
static char cForClientPullDown[256]={""};
static unsigned uForClient=0;


unsigned IsAuthUser(char *cLabel);
void PermLevelDropDown(char *cuPerm);

void EncryptPasswdWithSalt(char *cPasswd,char *cSalt);
void GetClientMaxParams(unsigned uClient,unsigned *uMaxSites,unsigned *uMaxIPs);
char *UserLevel(unsigned uPermLevel);
void GetConfiguration(char *cDefault,char *cValue,unsigned uHtml);
unsigned uMaxClientsReached(unsigned uClient);
void tTablePullDownResellers(int unsigned uSelector);

//ModuleFunctionProtos()


void tClientNavList(void);

void ExtProcesstClientVars(pentry entries[], int x)
{

	register int i;
	
	for(i=0;i<x;i++)
	{
		if(!strcmp(entries[i].name,"cPasswd"))
			sprintf(cPasswd,"%.15s",entries[i].val);
		else if(!strcmp(entries[i].name,"cExtLabel"))
			sprintf(cExtLabel,"%.32s",entries[i].val);
		else if(!strcmp(entries[i].name,"cuPerm"))
		{
			sprintf(cuPerm,"%.32s",entries[i].val);
			if(cuPerm[0]=='C')
				uPerm=7;
			else if(cuPerm[1]=='e')
				uPerm=8;
			else if(cuPerm[0]=='A')
				uPerm=10;
			else if(cuPerm[1]=='o')
				uPerm=12;
		}
		else if(!strcmp(entries[i].name,"cForClientPullDown"))
		{
			strcpy(cForClientPullDown,entries[i].val);
			uForClient=ReadPullDown("tClient","cLabel",
					cForClientPullDown);
		}
	}

}//void ExtProcesstClientVars(pentry entries[], int x)


void ExttClientCommands(pentry entries[], int x)
{
        MYSQL_RES *res;

	if(!strcmp(function,"tClientTools"))
	{
		//ModuleFunctionProcess()

		//Default wizard like two step creation and deletion
		if(!strcmp(command,LANG_NB_NEW))
                {
			if(uPermLevel>=8)
			{
				ProcesstClientVars(entries,x);
				if(uPermLevel==8 && uMaxClientsReached(uLoginClient))
				{
					mode=0;
					tClient("Your reseller maximum of customers has been reached");
				}
				mode=2000;
				tClient(LANG_NB_CONFIRMNEW);
			}
                }
		else if(!strcmp(command,LANG_NB_CONFIRMNEW))
                {
			if(uPermLevel>=8)
			{
				ProcesstClientVars(entries,x);
				if(uPermLevel==8 && uMaxClientsReached(uLoginClient))
				{
					mode=0;
					tClient("Your reseller maximum of customers has been reached");
				}
				if(!uForClient)
					uOwner=uLoginClient;
				else
					uOwner=uForClient;
				uClient=0;
				uCreatedBy=uLoginClient;
				uModBy=0;//Never modified
				NewtClient(1);
			}
		}
		else if(!strcmp(command,LANG_NB_DELETE))
                {
                        ProcesstClientVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=8 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
                        	mode=2001;
                        	tClient(LANG_NB_CONFIRMDEL);
			}
                }
                else if(!strcmp(command,LANG_NB_CONFIRMDEL))
                {
                        ProcesstClientVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=8 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
                        	mode=2001;
				sprintf(query,"SELECT uZone FROM tZone WHERE uOwner=%u OR uCreatedBy=%u",uClient,uClient);
				mysql_query(&mysql,query);
        			if(mysql_errno(&mysql))
                			tClient(mysql_error(&mysql));
        			res=mysql_store_result(&mysql);
				if(mysql_num_rows(res))
					tClient("Can't delete client with zones");
				mysql_free_result(res);
				sprintf(query,"DELETE FROM tAuthorize WHERE cLabel='%s'",cLabel);
				mysql_query(&mysql,query);
        			if(mysql_errno(&mysql))
                			tClient(mysql_error(&mysql));
                        	mode=5;
                        	DeletetClient();
			}
                }
		else if(!strcmp(command,LANG_NB_MODIFY))
                {
                        ProcesstClientVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=8 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				mode=2002;
				tClient(LANG_NB_CONFIRMMOD);
			}
                }
                else if(!strcmp(command,LANG_NB_CONFIRMMOD))
                {
                        ProcesstClientVars(entries,x);
			if(uOwner) GetClientOwner(uOwner,&uReseller);
			if( (uPermLevel>=8 && uOwner==uLoginClient)
				|| (uPermLevel>9 && uOwner!=1)
				|| (uPermLevel>7 && uReseller==uLoginClient) )
			{
				uModBy=uLoginClient;
				if(uForClient)
					uOwner=uForClient;
				ModtClient();
			}
                }

                else if(!strcmp(command,"Authorize"))
                {
			//Level 8!
                        ProcesstClientVars(entries,x);
			if( uClient && (uPermLevel>9 || 
					(uPermLevel>7 && uOwner==uLoginClient)))
			{
				mode=3000;
				tClient("Enter passwd, user level and confirm");
			}
		}
                else if(!strcmp(command,"Confirm Authorize"))
                {
                        ProcesstClientVars(entries,x);
			if( uClient && (uPermLevel>9 || 
					(uPermLevel>7 && uOwner==uLoginClient)))
			{
				time_t clock;

			        time(&clock);
				
				if(strlen(cPasswd)<6)
				{
					mode=3000;
					tClient("Passwd must be at least 6 chars!");
				}

				if(uPerm<7 || uPerm>12)
				{
					mode=3000;
					sprintf(query,"uPerm level error:%u",uPerm);
					tClient(query);
				}
			
				//Disallow Reseller level (8) from granting more than
				//Customer level permissions (7)
				if(uPerm>7 && uPermLevel<10) uPerm=7;

				//Disallow Admin level (10) users from granting
				//more than Reseller level permissions (8)
				if(uPerm>8 && uPermLevel<12) uPerm=8;

				EncryptPasswdWithSalt(cPasswd,"..");
sprintf(query,"INSERT INTO tAuthorize SET  cLabel='%s', uPerm=%u, uCertClient=%u, cPasswd='%s', uOwner=%u, uCreatedBy=%u, uCreatedDate=%lu, uModDate=0, cIPMask='0.0.0.0'",
			TextAreaSave(cLabel)
			,uPerm
			,uClient
			,cPasswd
			,uLoginClient
			,uLoginClient
			,(long unsigned)clock
			);

				mysql_query(&mysql,query);
        			if(mysql_errno(&mysql))
                			tClient(mysql_error(&mysql));
				tClient("Subclient authorized");
			}

		}//Confirm auth

	}

}//void ExttClientCommands(pentry entries[], int x)


void ExttClientButtons(void)
{
	printf("<table width=260 border=0 bgcolor=#9BC1B3 valign=center>\n");
        printf("<tr><td>");

	printf("<font face=Arial,Helvetica>");
	printf("<font size=2>");

	switch(mode)
        {
                case 2000:
			printf("Enter required data<br>");
			if(uPermLevel>7)
			{
				printf("<p><u>Create for customer</u><br>");
				tTablePullDownResellers(uForClient);
			}
                        printf("<br><font size=1>");
                        printf(LANG_NBB_CONFIRMNEW);
			printf("<br>\n");
                break;

                case 2001:
                        printf("<font size=1>");
                        printf(LANG_NBB_CONFIRMDEL);
			printf("<br>\n");
                break;

                case 2002:
			printf("Review record data<br>");
			if(uPermLevel>7)
			{
				printf("<p><u>Change uOwner</u><br>");
				tTablePullDownResellers(uForClient);
			}
                        printf("<br><font size=1>");
                        printf(LANG_NBB_CONFIRMMOD);
			printf("<br>\n");
                break;

                case 3000:
			if(uPermLevel>7)
				PermLevelDropDown(cuPerm);
			printf("<br>Passwd <input type=text title='Login passwd' name=cPasswd size=20 maxlength=15>");
                        printf("<font size=1>");
			printf("<input class=largeButton title='Confirm authorization' type=submit name=command value='Confirm Authorize'>");
                break;
	}

	if(uClient && uPermLevel>7 && uClient!=uLoginClient 
			&& mode!=3000 && !IsAuthUser(cLabel) &&mode!=5 )
	{
		printf("<font size=1>");
		printf("<input class=largeButton title='Authorize this subclient to create zones' type=submit name=command value='Authorize'>");
	}

	printf("<font size=2>");
        printf("<p><u>Authorized Clients</u><br>\n");
	tClientNavList();

        printf("</td></tr>\n");
        printf("</table>\n");

}//void ExttClientButtons(void)


void ExttClientAuxTable(void)
{

}//void ExttClientAuxTable(void)


void ExttClientGetHook(entry gentries[], int x)
{
	register int i;

	for(i=0;i<x;i++)
	{
		if(!strcmp(gentries[i].name,"uClient"))
		{
			sscanf(gentries[i].val,"%u",&uClient);
			mode=6;
		}
	}
	tClient("");

}//void ExttClientGetHook(entry gentries[], int x)


void ExttClientSelect(void)
{
        //Set non search query here for tTableName()
	if(uPermLevel>=9)
	sprintf(query,"SELECT %s FROM tClient ORDER BY cLabel",VAR_LIST_tClient);
	else
	sprintf(query,"SELECT %s FROM tClient WHERE uOwner=%u OR uClient=%u ORDER BY cLabel",VAR_LIST_tClient,uLoginClient,uLoginClient);

}//void ExttClientSelect(void)


void ExttClientSelectRow(void)
{
	if(uPermLevel<10)
                sprintf(query,"SELECT %s FROM tClient WHERE (uOwner=%u OR uClient=%u) AND uClient=%u", VAR_LIST_tClient, uLoginClient,uLoginClient,uClient);
	else
                sprintf(query,"SELECT %s FROM tClient WHERE uClient=%u",
			VAR_LIST_tClient,uClient);

}//void ExttClientSelectRow(void)


void ExttClientListSelect(void)
{
	char cCat[512];

	if(uPermLevel<10)
		sprintf(query,"SELECT %s FROM tClient WHERE (tClient.uOwner=%u OR tClient.uClient=%u)",
				VAR_LIST_tClient,
				uLoginClient,
				uLoginClient);
	else
                sprintf(query,"SELECT %s FROM tClient",
				VAR_LIST_tClient);

	//Changes here must be reflected below in ExttClientListFilter()
        if(!strcmp(filter,"uClient"))
        {
                sscanf(command,"%u",&uClient);
		if(uPermLevel<10)
			strcat(query," AND ");
		else
			strcat(query," WHERE ");
		sprintf(cCat,"uClient=%u ORDER BY uClient",
						uClient);
		strcat(query,cCat);
        }
        else if(1)
        {
                //None NO FILTER
                strcpy(filter,"None");
		strcat(query," ORDER BY uClient");
        }

}//void ExttClientListSelect(void)


void ExttClientListFilter(void)
{
        //Filter
        printf("<td align=right >Select ");
        printf("<select name=filter>");
        if(strcmp(filter,"uClient"))
                printf("<option>uClient</option>");
        else
                printf("<option selected>uClient</option>");
        if(strcmp(filter,"None"))
                printf("<option>None</option>");
        else
                printf("<option selected>None</option>");
        printf("</select>");

}//void ExttClientListFilter(void)


void ExttClientNavBar(void)
{
	if(uOwner) GetClientOwner(uOwner,&uReseller);

	printf(LANG_NBB_SKIPFIRST);
	printf(LANG_NBB_SKIPBACK);
	printf(LANG_NBB_SEARCH);

	if(uPermLevel>=8)
		printf(LANG_NBB_NEW);

	if( (uPermLevel>=8 && uOwner==uLoginClient)
			|| (uPermLevel>9 && uOwner!=1)
			|| (uPermLevel>7 && uReseller==uLoginClient) )
		printf(LANG_NBB_MODIFY);

	if( (uPermLevel>=8 && uOwner==uLoginClient)
			|| (uPermLevel>9 && uOwner!=1)
			|| (uPermLevel>7 && uReseller==uLoginClient) )
		printf(LANG_NBB_DELETE);

	printf(LANG_NBB_LIST);

	printf(LANG_NBB_SKIPNEXT);
	printf(LANG_NBB_SKIPLAST);

}//void ExttClientNavBar(void)


//TODO make into recursive function
void tClientNavList(void)
{
        MYSQL_RES *res;
        MYSQL_ROW field;
        MYSQL_RES *res2;
        MYSQL_ROW field2;
        MYSQL_RES *res3;
        MYSQL_ROW field3;
	
	unsigned uLocalClient=0;
	unsigned uPerm=0;
	char *cMarker;

//First select root clients, that is clients owned by themselves
if(uPermLevel>9)
{
	sprintf(query,"SELECT uClient,cLabel FROM tClient WHERE uOwner=uClient");

        mysql_query(&mysql,query);
        if(mysql_errno(&mysql))
        {
                printf("%s",mysql_error(&mysql));
                return;
        }

        res=mysql_store_result(&mysql);
        while((field=mysql_fetch_row(res)))
        {
		sscanf(field[0],"%u",&uLocalClient);
		if((uPerm=IsAuthUser(field[1])))
		{
			if(uLocalClient==uLoginClient)
				cMarker="*";
			else
				cMarker="&ordf;";

			printf("<a class=darkLink href=mysqlBind.cgi?function=tClient&uClient=%s>%s%s (%s)</a><br>\n",field[0],cMarker,field[1],UserLevel(uPerm));
		}
		else
		{
			printf("<a class=darkLink href=mysqlBind.cgi?function=tClient&uClient=%s>%s</a><br>\n",field[0],field[1]);
		}

		//Sub select reseller
sprintf(query,"SELECT tClient.uClient,tClient.cLabel FROM tClient,tAuthorize WHERE tClient.uClient=tAuthorize.uCertClient AND tAuthorize.uPerm=8 AND tClient.uOwner=%u",
			uLocalClient);
        	mysql_query(&mysql,query);
        	if(mysql_errno(&mysql))
        	{
			printf("%s",mysql_error(&mysql));
			return;
		}

		res2=mysql_store_result(&mysql);
        	while((field2=mysql_fetch_row(res2)))
        	{
			sscanf(field2[0],"%u",&uLocalClient);
			if((uPerm=IsAuthUser(field2[1])))
			{
				if(uLocalClient==uLoginClient)
					cMarker="*";
				else
					cMarker="&ordf;";

				printf("&nbsp;&nbsp;<a class=darkLink href=mysqlBind.cgi?function=tClient&uClient=%s>%s%s (%s)</a><br>\n",field2[0],cMarker,field2[1],UserLevel(uPerm));
			}
			else
			{
				printf("&nbsp;&nbsp;<a class=darkLink href=mysqlBind.cgi?function=tClient&uClient=%s>%s</a><br>\n",field2[0],field2[1]);
			}


			//Sub select end-user customer
sprintf(query,"SELECT tClient.uClient,tClient.cLabel FROM tClient,tAuthorize WHERE tClient.uClient=tAuthorize.uCertClient AND tAuthorize.uPerm=7 AND tClient.uOwner=%u",
			uLocalClient);
	        	mysql_query(&mysql,query);
			if(mysql_errno(&mysql))
			{
				printf("%s",mysql_error(&mysql));
				return;
			}

			res3=mysql_store_result(&mysql);
			while((field3=mysql_fetch_row(res3)))
			{
				sscanf(field3[0],"%u",&uLocalClient);
				if((uPerm=IsAuthUser(field3[1])))
				{
					if(uLocalClient==uLoginClient)
						cMarker="*";
					else
						cMarker="&ordf;";

					printf("&nbsp;&nbsp;&nbsp;&nbsp;<a class=darkLink href=mysqlBind.cgi?function=tClient&uClient=%s>%s%s (%s)</a><br>\n",field3[0],cMarker,field3[1],UserLevel(uPerm));
				}
				else
				{
					printf("&nbsp;&nbsp;&nbsp;&nbsp;<a class=darkLink href=mysqlBind.cgi?function=tClient&uClient=%s>%s</a><br>\n",field3[0],field3[1]);
				}
			}//sub select customer
        		mysql_free_result(res3);

		}//sub select reseller
        	mysql_free_result(res2);
        }
        mysql_free_result(res);

}
else 
{
	sprintf(query,"SELECT uClient,cLabel FROM tClient WHERE uClient=%u",uLoginClient);

        mysql_query(&mysql,query);
        if(mysql_errno(&mysql))
        {
                printf("%s",mysql_error(&mysql));
                return;
        }

        res=mysql_store_result(&mysql);
        while((field=mysql_fetch_row(res)))
        {
		sscanf(field[0],"%u",&uLocalClient);
		if((uPerm=IsAuthUser(field[1])))
		{
			if(uLocalClient==uLoginClient)
				cMarker="*";
			else
				cMarker="&ordf;";

			printf("<a class=darkLink href=mysqlBind.cgi?function=tClient&uClient=%s>%s%s (%s)</a><br>\n",field[0],cMarker,field[1],UserLevel(uPerm));
		}
		else
		{
			printf("<a class=darkLink href=mysqlBind.cgi?function=tClient&uClient=%s>%s</a><br>\n",field[0],field[1]);
		}

		//Sub select end-user customer
sprintf(query,"SELECT tClient.uClient,tClient.cLabel FROM tClient,tAuthorize WHERE tClient.uClient=tAuthorize.uCertClient AND tAuthorize.uPerm=7 AND tClient.uOwner=%u",
			uLocalClient);
	        mysql_query(&mysql,query);
		if(mysql_errno(&mysql))
		{
			printf("%s",mysql_error(&mysql));
			return;
		}

		res3=mysql_store_result(&mysql);
		while((field3=mysql_fetch_row(res3)))
		{
			sscanf(field3[0],"%u",&uLocalClient);
			if((uPerm=IsAuthUser(field3[1])))
			{
				if(uLocalClient==uLoginClient)
					cMarker="*";
				else
					cMarker="&ordf;";

				printf("&nbsp;&nbsp;&nbsp;&nbsp;<a class=darkLink href=mysqlBind.cgi?function=tClient&uClient=%s>%s%s (%s)</a><br>\n",field3[0],cMarker,field3[1],UserLevel(uPerm));
			}
			else
			{
				printf("&nbsp;&nbsp;&nbsp;&nbsp;<a class=darkLink href=mysqlBind.cgi?function=tClient&uClient=%s>%s</a><br>\n",field3[0],field3[1]);
			}
		}//sub select customer
        	mysql_free_result(res3);

	}//outside reseller select
        mysql_free_result(res);
}

}//void tClientNavList(void)


unsigned IsAuthUser(char *cLabel)
{
	unsigned uRetVal=0;
        MYSQL_RES *res;
        MYSQL_ROW field;

        sprintf(query,"SELECT uPerm FROM tAuthorize WHERE cLabel='%s'",cLabel);
        mysql_query(&mysql,query);
        if(mysql_errno(&mysql))
        {
                printf("%s",mysql_error(&mysql));
                return(0);
        }
        res=mysql_store_result(&mysql);
        if((field=mysql_fetch_row(res)))
		sscanf(field[0],"%u",&uRetVal);
        mysql_free_result(res);
	
	return(uRetVal);

}//unsigned IsAuthUser(char *cLabel)


void PermLevelDropDown(char *cuPerm)
{
	printf("User Level ");

	printf("<select name=cuPerm>\n");

	if(uPermLevel>7)
	{
	if(cuPerm[0]=='C')
		printf("<option selected>Customer</option>\n");
	else
		printf("<option>Customer</option>\n");
	}

	if(uPermLevel>9)
	{
		if(cuPerm[1]=='e')
			printf("<option selected>Reseller</option>\n");
		else
			printf("<option>Reseller</option>\n");
	}

	if(uPermLevel>11)
	{
		if(cuPerm[0]=='A')
			printf("<option selected>Admin</option>\n");
		else
			printf("<option>Admin</option>\n");

		if(cuPerm[1]=='o')
			printf("<option selected>Root</option>\n");
		else
			printf("<option>Root</option>\n");
	}

	printf("</select>\n");

}//void PermLevelDropDown(char *cuPerm)


unsigned uMaxClientsReached(unsigned uClient)
{
        MYSQL_RES *res;
        MYSQL_ROW field;
	unsigned uRetVal=1;
	unsigned uMaxClients=0;
	unsigned uClients=0;

	sprintf(query,"SELECT cInfo FROM tClient WHERE uClient=%u",uClient);

        mysql_query(&mysql,query);
        if(mysql_errno(&mysql))
                tClient(mysql_error(&mysql));

        res=mysql_store_result(&mysql);
        if((field=mysql_fetch_row(res)))
        {
		char *cp;

		if((cp=strstr(field[0],"uMaxClients=")))
			sscanf(cp+12,"%u",&uMaxClients);
	}
	mysql_free_result(res);

	sprintf(query,"SELECT COUNT(uClient) FROM tClient WHERE uOwner=%u",uClient);

        mysql_query(&mysql,query);
        if(mysql_errno(&mysql))
                tClient(mysql_error(&mysql));

        res=mysql_store_result(&mysql);
        if((field=mysql_fetch_row(res)))
		sscanf(field[0],"%u",&uClients);
	mysql_free_result(res);

	if(uClients<uMaxClients)
		uRetVal=0;

	return(uRetVal);

}//unsigned uMaxClientsReached(unsigned uClient)


void tTablePullDownResellers(int unsigned uSelector)
{
        MYSQL_RES *res;         
        MYSQL_ROW field;

        register int i,n;
      
	sprintf(query,"SELECT tClient.uClient,tClient.cLabel FROM tClient,tAuthorize WHERE tClient.uClient=tAuthorize.uCertClient AND tAuthorize.uPerm=8 ORDER BY cLabel");


        mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
        {
                printf("%s",mysql_error(&mysql));
                return;
        }
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

        if(i>0)
        {
                printf("<select name=cForClientPullDown>\n");

                //Default no selection
                printf("<option>---</option>\n");

                for(n=0;n<i;n++)
                {
                        int unsigned field0=0;

                        field=mysql_fetch_row(res);
                        sscanf(field[0],"%u",&field0);

                        if(uSelector != field0)
                        {
                                printf("<option>%s</option>\n",field[1]);
                        }
                        else
                        {
                                printf("<option selected>%s</option>\n",field[1]);
                        }
                }
        }
        else
        {
        printf("<select name=cForClientPullDown><option>---</option></select>\n");
        }
        printf("</select>\n");

}//tTablePullDownResellers()
