/*
FILE
	tResource source code of mysqlBind.cgi
	(built by mysqlRAD2.cgi (c) Gary Wallis 2001,2002 GPL Licensed)
	$Id: tresource.c,v 1.12 2003/11/13 20:44:21 ggw Exp $
	(tAuthorize.cPasswd template set member)
PURPOSE
*/

#include "mysqlrad.h"

//Table Variables
//uResource: Primary Key
static unsigned uResource=0;
//uZone: Belongs to this tZone
static unsigned uZone=0;
//cName: Host name relative, full or emtpy=zone
static char cName[101]={""};
//uTTL: Optional TTL for this record only
static unsigned uTTL=0;
//uRRType: Pulldown of resource record type table
static unsigned uRRType=0;
static char cuRRTypePullDown[256]={""};
//cParam1: Parameter 1 field
static char cParam1[101]={""};
//cParam2: Parameter 2 field
static char cParam2[101]={""};
//cComment: Optional comment
static char *cComment={""};
//uOwner: Record owner
static unsigned uOwner=0;
//uCreatedBy: uClient for last insert
static unsigned uCreatedBy=0;
#define ISM3FIELDS
//uCreatedDate: Unix seconds date last insert
static long unsigned uCreatedDate=0;
//uModBy: uClient for last update
static unsigned uModBy=0;
//uModDate: Unix seconds date last update
static long unsigned uModDate=0;




#define VAR_LIST_tResource "tResource.uResource,tResource.uZone,tResource.cName,tResource.uTTL,tResource.uRRType,tResource.cParam1,tResource.cParam2,tResource.cComment,tResource.uOwner,tResource.uCreatedBy,tResource.uCreatedDate,tResource.uModBy,tResource.uModDate"

 //Local only
void Insert_tResource(void);
void Update_tResource(char *rowid);
int InsertUpdate_tResource(char *cKey);
void ProcesstResourceListVars(pentry entries[], int x);

 //In tResourcefunc.h file included below
void ExtProcesstResourceVars(pentry entries[], int x);
void ExttResourceCommands(pentry entries[], int x);
void ExttResourceButtons(void);
void ExttResourceNavBar(void);
void ExttResourceGetHook(entry gentries[], int x);
void ExttResourceSelect(void);
void ExttResourceSelectRow(void);
void ExttResourceListSelect(void);
void ExttResourceListFilter(void);
void ExttResourceAuxTable(void);

#include "tresourcefunc.h"

 //Table Variables Assignment Function
void ProcesstResourceVars(pentry entries[], int x)
{
	register int i;


	for(i=0;i<x;i++)
	{
		if(!strcmp(entries[i].name,"uResource"))
			sscanf(entries[i].val,"%u",&uResource);
		else if(!strcmp(entries[i].name,"uZone"))
			sscanf(entries[i].val,"%u",&uZone);
		else if(!strcmp(entries[i].name,"cName"))
			sprintf(cName,"%.100s",FQDomainName(entries[i].val));
		else if(!strcmp(entries[i].name,"uTTL"))
			sscanf(entries[i].val,"%u",&uTTL);
		else if(!strcmp(entries[i].name,"uRRType"))
			sscanf(entries[i].val,"%u",&uRRType);
		else if(!strcmp(entries[i].name,"cuRRTypePullDown"))
		{
			sprintf(cuRRTypePullDown,"%.255s",entries[i].val);
			uRRType=ReadPullDown("tRRType","cLabel",cuRRTypePullDown);
		}
		else if(!strcmp(entries[i].name,"cParam1"))
			sprintf(cParam1,"%.100s",entries[i].val);
		else if(!strcmp(entries[i].name,"cParam2"))
			sprintf(cParam2,"%.100s",entries[i].val);
		else if(!strcmp(entries[i].name,"cComment"))
			cComment=entries[i].val;
		else if(!strcmp(entries[i].name,"uOwner"))
			sscanf(entries[i].val,"%u",&uOwner);
		else if(!strcmp(entries[i].name,"uCreatedBy"))
			sscanf(entries[i].val,"%u",&uCreatedBy);
		else if(!strcmp(entries[i].name,"uCreatedDate"))
			sscanf(entries[i].val,"%lu",&uCreatedDate);
		else if(!strcmp(entries[i].name,"uModBy"))
			sscanf(entries[i].val,"%u",&uModBy);
		else if(!strcmp(entries[i].name,"uModDate"))
			sscanf(entries[i].val,"%lu",&uModDate);

	}

	//After so we can overwrite form data if needed.
	ExtProcesstResourceVars(entries,x);

}//ProcesstResourceVars()


void ProcesstResourceListVars(pentry entries[], int x)
{
        register int i;

        for(i=0;i<x;i++)
        {
                if(!strncmp(entries[i].name,"ED",2))
                {
                        sscanf(entries[i].name+2,"%u",&uResource);
                        mode=6;
                        tResource("");
                }
        }
}//void ProcesstResourceListVars(pentry entries[], int x)


int tResourceCommands(pentry entries[], int x)
{
	ProcessControlVars(entries,x);

	ExttResourceCommands(entries,x);

	if(!strcmp(function,"tResourceTools"))
	{
		if(!strcmp(find,LANG_NB_LIST))
		{
			tResourceList();
		}

		//Default
		ProcesstResourceVars(entries,x);
		tResource("");
	}
	else if(!strcmp(function,"tResourceList"))
	{
		ProcessControlVars(entries,x);
		ProcesstResourceListVars(entries,x);
		tResourceList();
	}

	return(0);

}//tResourceCommands()


void tResource(char *result)
{
	MYSQL_RES *res;
	MYSQL_RES *res2;
	MYSQL_ROW field;

	//Internal skip reloading
	if(!result[0])
	{
		if(mode)
			ExttResourceSelectRow();
		else
			ExttResourceSelect();

		mysql_query(&mysql,query);
		if(mysql_errno(&mysql))
        	{
			if(strstr(mysql_error(&mysql)," doesn't exist"))
                	{
				CreatetResource();
				mysqlBind("New tResource table created");
                	}
			else
			{
				mysqlBind(mysql_error(&mysql));
			}
        	}

		res=mysql_store_result(&mysql);
		if((i=mysql_num_rows(res)))
		{
			if(mode==6)
			{
			sprintf(query,"SELECT _rowid FROM tResource WHERE uResource=%u"
						,uResource);
			mysql_query(&mysql,query);
			res2=mysql_store_result(&mysql);
			field=mysql_fetch_row(res2);
			sscanf(field[0],"%lu",&rowid);
			rowid++;
			}
			PageMachine("",0,"");
			if(!mode) mysql_data_seek(res,rowid-1);
			field=mysql_fetch_row(res);
		sscanf(field[0],"%u",&uResource);
		sscanf(field[1],"%u",&uZone);
		sprintf(cName,"%.100s",field[2]);
		sscanf(field[3],"%u",&uTTL);
		sscanf(field[4],"%u",&uRRType);
		sprintf(cParam1,"%.100s",field[5]);
		sprintf(cParam2,"%.100s",field[6]);
		cComment=field[7];
		sscanf(field[8],"%u",&uOwner);
		sscanf(field[9],"%u",&uCreatedBy);
		sscanf(field[10],"%lu",&uCreatedDate);
		sscanf(field[11],"%u",&uModBy);
		sscanf(field[12],"%lu",&uModDate);

		}

	}//Internal Skip

	Header_ism3(":: tResource",0);
	printf("<form action=mysqlBind.cgi method=post >\n");
	printf("<table width=900 border=0 bgcolor=#A9BEC0 valign=center>\n");
	printf("<tr><td colspan=2><font face=Arial,Helvetica size=2>");


	ExttResourceNavBar();

	printf("<input type=hidden name=function value=tResourceTools>");
	printf("<input type=hidden name=rowid value=%lu>",rowid);
	if(i)
	{
		printf(" <font color=blue >");
		if(mode==6)
			//printf(" Found");
			printf(LANG_NBR_FOUND);
		else if(mode==5)
			//printf(" Modified");
			printf(LANG_NBR_MODIFIED);
		else if(mode==4)
			//printf(" New");
			printf(LANG_NBR_NEW);
		printf(LANG_NBRF_SHOWING,rowid,i);
	}
	else
	{
		if(!result[0])
		//printf(" No records found");
		printf(LANG_NBR_NORECS);
	}
	if(result[0]) printf(" <b> %s",result);
	printf("</td></tr>");
	printf("<tr><td valign=top>");

        ExttResourceButtons();

        printf("</td><td valign=top>");
	printf("<table width=630 border=0 bgcolor=#9BC1B3 valign=center>\n");

	if(mode==2000 || mode==2002)
		tResourceInputContent();
	else
		tResourceContent();

	printf("</table>\n");
	printf("</table>\n");

	//Bottom table
        ExttResourceAuxTable();

	printf("</font></form>\n");
	Footer_ism3();

}//end of tResource();


void tResourceContent(void)
{
	unsigned uZoneOwner=0;
	unsigned uReseller=0;

	if(uPermLevel<9)
	{
		sscanf(ForeignKey("tZone","uOwner",uZone),"%u",&uZoneOwner);
		if(uZoneOwner) GetClientOwner(uZoneOwner,&uReseller);
	}


	OpenRow(LANG_FL_tResource_uResource,"white");
	printf("%u<input type=hidden name=uResource value=%u >\n",uResource,uResource);
	printf("&nbsp;&nbsp;");
	printf("&nbsp;&nbsp; <font color=%s>%s</font> ",IsZero(uZone),LANG_FL_tResource_uZone);
	printf("%s<input type=hidden name=uZone value=%u >\n",ForeignKey("tZone","cZone",uZone),uZone);
	printf("&nbsp;&nbsp;");
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_cName,"white");
	printf("%s<input type=hidden name=cName value=\"%s\">",cName,EncodeDoubleQuotes(cName));
	printf("&nbsp;&nbsp;");
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_uTTL,"white");
	printf("%u<input type=hidden name=uTTL value=%u >\n",uTTL,uTTL);
	printf("&nbsp;&nbsp;");
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_uRRType,IsZero(uRRType));
	tTablePullDownReadOnly("tRRType;cuRRTypePullDown","cLabel","cLabel",uRRType);
	printf("&nbsp;&nbsp;");
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_cParam1,EmptyString(cParam1));
	printf("%s<input type=hidden name=cParam1 value=\"%s\">",cParam1,EncodeDoubleQuotes(cParam1));
	printf("&nbsp;&nbsp;");
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_cParam2,"white");
	printf("%s<input type=hidden name=cParam2 value=\"%s\">",cParam2,EncodeDoubleQuotes(cParam2));
	printf("&nbsp;&nbsp;");
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_cComment,"white");
	printf("<pre><font face=Arial,Helvetica>%s</pre>\n\n",
		TransformAngleBrackets(cComment));
	printf("<input type=hidden name=cComment value=\"%s\">",
		EncodeDoubleQuotes(cComment));
	printf("&nbsp;&nbsp;");
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_uOwner,"white");
	if( uPermLevel>9 || uOwner==uLoginClient || uReseller==uLoginClient )
	printf("%s<input type=hidden name=uOwner value=%u >\n",ForeignKey("tClient","cLabel",uOwner),uOwner);
	else
		printf("---\n");
	printf("&nbsp;&nbsp;");
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_uCreatedBy,"white");
	if( uPermLevel>9 || uOwner==uLoginClient || uReseller==uLoginClient )
	printf("%s<input type=hidden name=uCreatedBy value=%u >\n",ForeignKey("tClient","cLabel",uCreatedBy),uCreatedBy);
	else
		printf("---\n");
	printf("&nbsp;&nbsp;");
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_uCreatedDate,"white");
	if(uCreatedDate)
		printf("%s\n\n",ctime(&uCreatedDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uCreatedDate value=%lu >\n",uCreatedDate);
	printf("&nbsp;&nbsp;");
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_uModBy,"white");
	if( uPermLevel>9 || uOwner==uLoginClient || uReseller==uLoginClient )
		printf("%s<input type=hidden name=uModBy value=%u >\n",ForeignKey("tClient","cLabel",uModBy),uModBy);
	else
		printf("---\n");
	printf("&nbsp;&nbsp;");
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_uModDate,"white");
	if(uModDate)
		printf("%s\n\n",ctime(&uModDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uModDate value=%lu >\n",uModDate);
	printf("&nbsp;&nbsp;");
	printf("</tr>\n");



}//tResourceContent()


void tResourceInputContent(void)
{

	unsigned uZoneOwner=0;
	unsigned uReseller=0;

	if(uPermLevel<9)
	{
		sscanf(ForeignKey("tZone","uOwner",uZone),"%u",&uZoneOwner);
		if(uZoneOwner) GetClientOwner(uZoneOwner,&uReseller);
	}


	OpenRow(LANG_FL_tResource_uResource,"white");
	if(uPermLevel>=20)
		printf("<input title='%s' type=text name=uResource value=%u size=16 maxlength=10>\n",LANG_FT_tResource_uResource,uResource);
	else
		printf("%u<input type=hidden name=uResource value=%u >\n",uResource,uResource);
	printf("&nbsp;&nbsp; <font color=%s>%s</font> ",IsZero(uZone),LANG_FL_tResource_uZone);
	printf("%s<input type=hidden name=uZone value=%u >\n",ForeignKey("tZone","cZone",uZone),uZone);
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_cName,"white");
	printf("<input title='%s' type=text name=cName value=\"%s\" size=40 maxlength=100>\n",LANG_FT_tResource_cName,EncodeDoubleQuotes(cName));
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_uTTL,"white");
	printf("<input title='%s' type=text name=uTTL value=%u size=16 maxlength=10>\n",LANG_FT_tResource_uTTL,uTTL);
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_uRRType,IsZero(uRRType));
	if(uPermLevel>=0)
		tTablePullDown("tRRType;cuRRTypePullDown","cLabel","cLabel",uRRType);
	else
	{
		tTablePullDownReadOnly("tRRType;cuRRTypePullDown","cLabel","cLabel",uRRType);
	}
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_cParam1,EmptyString(cParam1));
	printf("<input title='%s' type=text name=cParam1 value=\"%s\" size=40 maxlength=100>\n",LANG_FT_tResource_cParam1,EncodeDoubleQuotes(cParam1));
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_cParam2,"white");
	printf("<input title='%s' type=text name=cParam2 value=\"%s\" size=40 maxlength=100>\n",LANG_FT_tResource_cParam2,EncodeDoubleQuotes(cParam2));
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_cComment,"white");
	printf("<textarea title='%s' cols=40 wrap=hard rows=3 name=cComment>%s</textarea>\n\n",LANG_FT_tResource_cComment,cComment);
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_uOwner,"white");
	if( uPermLevel>9 || uOwner==uLoginClient || uReseller==uLoginClient )
	printf("%s<input type=hidden name=uOwner value=%u >\n",ForeignKey("tClient","cLabel",uOwner),uOwner);
	else
		printf("---\n\n");
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_uCreatedBy,"white");
	if( uPermLevel>9 || uOwner==uLoginClient || uReseller==uLoginClient )
		printf("%s<input type=hidden name=uCreatedBy value=%u >\n",ForeignKey("tClient","cLabel",uCreatedBy),uCreatedBy);
	else
		printf("---\n");
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_uCreatedDate,"white");
	if(uCreatedDate)
		printf("%s\n\n",ctime(&uCreatedDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uCreatedDate value=%lu >\n",uCreatedDate);
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_uModBy,"white");
	if( uPermLevel>9 || uOwner==uLoginClient || uReseller==uLoginClient )
	printf("%s<input type=hidden name=uModBy value=%u >\n",ForeignKey("tClient","cLabel",uModBy),uModBy);
	else
		printf("---\n");
	printf("</tr>\n");

	OpenRow(LANG_FL_tResource_uModDate,"white");
	if(uModDate)
		printf("%s\n\n",ctime(&uModDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uModDate value=%lu >\n",uModDate);
	printf("</tr>\n");


}//void tResourceInputContent(void)


void NewtResource(unsigned uMode)
{
	register int i=0;
	MYSQL_RES *res;

	//New select
	sprintf(query,"SELECT uResource FROM tResource\
				WHERE uResource=%u"
							,uResource);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	if(i) 
		//tResource("<blink>Record already exists");
		tResource(LANG_NBR_RECEXISTS);

	//insert query
	Insert_tResource();
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	//sprintf(query,"New record %u added");
	uResource=mysql_insert_id(&mysql);

	if(!uMode)
	{
	sprintf(query,LANG_NBR_NEWRECADDED,uResource);
	tResource(query);
	}

}//NewtResource(unsigned uMode)


void DeletetResource(void)
{
#ifdef ISM3FIELDS
	sprintf(query,"DELETE FROM tResource WHERE uResource=%u AND ( uOwner=%u OR %u>9 )"
					,uResource,uLoginClient,uPermLevel);
#else
	sprintf(query,"DELETE FROM tResource WHERE uResource=%u"
					,uResource);
#endif
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));

	//tResource("Record Deleted");
	if(mysql_affected_rows(&mysql)>0)
		tResource(LANG_NBR_RECDELETED);
	else
		tResource(LANG_NBR_RECNOTDELETED);

}//void DeletetResource(void)


void Insert_tResource(void)
{

#ifdef ISM3FIELDS
	time_t clock;

        time(&clock);
#endif

	//insert query

	//insert query
	sprintf(query,"INSERT INTO tResource SET  uResource=%u, uZone=%u, cName='%s', uTTL=%u, uRRType=%u, cParam1='%s', cParam2='%s', cComment='%s', uOwner=%u, uCreatedBy=%u, uCreatedDate=%lu, uModBy=%u, uModDate=0",
			uResource
			,uZone
			,TextAreaSave(cName)
			,uTTL
			,uRRType
			,TextAreaSave(cParam1)
			,TextAreaSave(cParam2)
			,TextAreaSave(cComment)
			,uOwner
			,uCreatedBy
			,(long unsigned)clock
			,uModBy
			);


	mysql_query(&mysql,query);
#ifdef ISM3FIELDS
	uCreatedDate=clock;
#endif

}//void Insert_tResource(void)


void Update_tResource(char *rowid)
{
#ifdef ISM3FIELDS
	time_t clock;

        time(&clock);
#endif

	//update query

	//update query
	sprintf(query,"UPDATE tResource SET uResource=%u,uZone=%u,cName='%s',uTTL=%u,uRRType=%u,cParam1='%s',cParam2='%s',cComment='%s',uModBy=%u,uModDate=%lu WHERE _rowid=%s",
			uResource
			,uZone
			,TextAreaSave(cName)
			,uTTL
			,uRRType
			,TextAreaSave(cParam1)
			,TextAreaSave(cParam2)
			,TextAreaSave(cComment)
			,uModBy
			,(long unsigned)clock
			,rowid);


	mysql_query(&mysql,query);

#ifdef ISM3FIELDS
	uModDate=clock;
#endif

}//void Update_tResource(void)


void ModtResource(void)
{
	register int i=0;
	MYSQL_RES *res;
	MYSQL_ROW field;
#ifdef ISM3FIELDS
	unsigned uPreModDate=0;

	//Mod select query
	if(uPermLevel<10)
	sprintf(query,"SELECT tResource.uResource,\
				tResource.uModDate\
				FROM tResource,tClient\
				WHERE tResource.uResource=%u\
				AND tResource.uOwner=tClient.uClient\
				AND (tClient.uOwner=%u OR tClient.uClient=%u)"
			,uResource,uLoginClient,uLoginClient);
	else
	sprintf(query,"SELECT uResource,uModDate FROM tResource\
				WHERE uResource=%u"
						,uResource);
#else
	sprintf(query,"SELECT uResource FROM tResource\
				WHERE uResource=%u"
						,uResource);
#endif

	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	//if(i<1) tResource("<blink>Record does not exist");
	if(i<1) tResource(LANG_NBR_RECNOTEXIST);
	//if(i>1) tResource("<blink>Multiple rows!");
	if(i>1) tResource(LANG_NBR_MULTRECS);

	field=mysql_fetch_row(res);
#ifdef ISM3FIELDS
	sscanf(field[1],"%u",&uPreModDate);
	if(uPreModDate!=uModDate) tResource(LANG_NBR_EXTMOD);
#endif

	Update_tResource(field[0]);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	//sprintf(query,"record %s modified",field[0]);
	sprintf(query,LANG_NBRF_REC_MODIFIED,field[0]);
	tResource(query);

}//ModtResource(void)


void tResourceList(void)
{
	MYSQL_RES *res;
	MYSQL_ROW field;

	ExttResourceListSelect();

	mysql_query(&mysql,query);
	if(mysql_error(&mysql)[0]) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	PageMachine("tResourceList",1,"");//1 is auto header list mode. Opens table!

	//Filter select drop down
	ExttResourceListFilter();

	printf("<input type=text size=16 name=command maxlength=98 value=\"%s\" >",command);

	printf("</table>\n");

	printf("<table bgcolor=#9BC1B3 border=0 width=900>\n");
	printf("<tr bgcolor=black><td><font face=arial,helvetica color=white>uResource<td><font face=arial,helvetica color=white>uZone<td><font face=arial,helvetica color=white>cName<td><font face=arial,helvetica color=white>uTTL<td><font face=arial,helvetica color=white>uRRType<td><font face=arial,helvetica color=white>cParam1<td><font face=arial,helvetica color=white>cParam2<td><font face=arial,helvetica color=white>cComment<td><font face=arial,helvetica color=white>uOwner<td><font face=arial,helvetica color=white>uCreatedBy<td><font face=arial,helvetica color=white>uCreatedDate<td><font face=arial,helvetica color=white>uModBy<td><font face=arial,helvetica color=white>uModDate</tr>");



	mysql_data_seek(res,start-1);

	for(n=0;n<(end-start+1);n++)
	{
		field=mysql_fetch_row(res);
		if(!field)
		{
			printf("<tr><td><font face=arial,helvetica>End of data</table>");
			Footer_ism3();
		}
			if(n % 2)
				printf("<tr bgcolor=#BBE1D3>");
			else
				printf("<tr>");
		printf("<td><font face=arial,helvetica size=1><input type=submit name=ED%s value=Edit></font> %s<td>%s<td>%s<td>%s<td>%s<td>%s<td>%s<td><pre><font face=Arial,Helvetica>%s<td>%s<td>%s<td>%s<td>%s<td>%s</tr>"
			,field[0]
			,field[0]
			,field[1]
			,field[2]
			,field[3]
			,field[4]
			,field[5]
			,field[6]
			,field[7]
			,field[8]
			,field[9]
			,field[10]
			,field[11]
			,field[12]
				);

	}

	printf("</table></form>\n");
	Footer_ism3();

}//tResourceList()


void CreatetResource(void)
{
	sprintf(query,"CREATE TABLE tResource ( uResource int unsigned NOT NULL DEFAULT 0 PRIMARY KEY AUTO_INCREMENT, cName varchar(100) NOT NULL DEFAULT '', uOwner int unsigned NOT NULL DEFAULT 0,index (uOwner), uCreatedBy int unsigned NOT NULL DEFAULT 0, uCreatedDate int unsigned NOT NULL DEFAULT 0, uModBy int unsigned NOT NULL DEFAULT 0, uModDate int unsigned NOT NULL DEFAULT 0, uTTL int unsigned NOT NULL DEFAULT 0, uRRType int unsigned NOT NULL DEFAULT 0, cParam1 varchar(100) NOT NULL DEFAULT '', cParam2 varchar(100) NOT NULL DEFAULT '', cComment text NOT NULL DEFAULT '', uZone int unsigned NOT NULL DEFAULT 0,index (uZone) )");
	mysql_query(&mysql,qstr);
	if(mysql_errno(&mysql))
		mysqlBind(mysql_error(&mysql));
}//CreatetResource()

