/*
FILE
	$Id: mainfunc.h,v 1.36 2003/12/22 16:27:39 ggw Exp $
	(sslauthlogin template set member)
PURPOSE

AUTHOR
	(Template and mysqlRAD2 author: (c) 2001,2002 Gary Wallis.)
 
*/


static char cTableList[32][32]=\
{"tZone","tResource","tRRType","tJob","tNameServer","tMailServer","tClient","tAuthorize","tConfiguration",""};


char cInitTableList[32][32]={"tRRType","tNameServer","tConfiguration","tMailServer",""};

void ExtMainShell(int argc, char *argv[]);
void Initialize(char *cPasswd);
void Backup(char *cPasswd);
void Restore(char *cPasswd, char *cTableName);
void RestoreAll(char *cPasswd);
void mySQLRootConnect(char *cPasswd);



void Tutorial(void);
void NamedConf(void);
void Admin(void);

//bind.c
void Status(char *cTarget);
void Import(void);

void ConnectMysqlServer(void);
void PassDirectHtml(char *file);


int ExtMainCommands(pentry entries[], int x)
{
	if(!strcmp(function,"MainTools"))
	{
		if(!strcmp(command,"Tutorial"))
		{
			Tutorial();
		}
		else if(!strcmp(command,"NamedConf"))
		{
			NamedConf();
		}
		else if(!strcmp(command,"Status"))
		{
			Status("");//Check NS by NS
		}
		else if(!strcmp(command,"Admin"))
		{
			Admin();
		}
		else if(!strcmp(command,"Import"))
		{
			Import();
		}

	}

	return(0);
}

void ExtMainContent(void)
{

	printf("<form action=mysqlBind.cgi method=post>");
	printf("<font size=1>");
	
	printf("<input type=hidden name=function value=MainTools>");
	printf("<input title='brief introduction' type=submit name=command value=Tutorial>");
	if(uPermLevel > 7 )
	{
		printf("<input title='special reseller and above operations' type=submit name=command value=Admin>");
	}
	

	printf("</form>");

}//void ExtMainContent(void)

//If called from command line
//In bind.c
void CreateMasterFiles(char *cMasterNS, char *cZone, 
		unsigned uModDBFiles, unsigned uModStubs);
void CreateSlaveFiles(char *cSlaveNS,char *cZone,char *cMasterIP);
void InstallNamedFiles(char *cIpNum);
void Initialize(char *cPasswd);
void ExportTable(char *cTable, char *cFile);
void SlaveJobQueue(char *cNameServer, char *cMasterIP);
void MasterJobQueue(char *cNameServer);
void ProcessExtJobQueue(char *cServer);//bind.c

void PrintUsage(char *arg0)
{
	printf("\n%s Menu (GPL License applies (C) 2003,2004 Gary Wallis)\n\nDatabase Ops:\n"
					,arg0);
	printf("\tInitialize|Backup|RestoreAll <mysql root passwd>\n");
	printf("\tRestore <mysql root passwd> <Restore table name>\n");
	printf("\tmysqlRadiusImport <server> <login> <passwd>\n");
	printf("\nCrontab Ops:\n");
	printf("\tProcessJobQueue <FQDN Server>\n");
	printf("\tProcessExtJobQueue <Server as in mysqlISP>\n");
	printf("\tjobqueue master <fqdn ns> (equivalent to ProcessJobQueue)\n");
	printf("\tjobqueue slave <fqdn ns> <master ip>\n");
	printf("\nSpecial Admin Ops:\n");
	printf("\tallfiles master|slave <fqdn ns> <master ip>\n");
	printf("\tinstallbind <listen ipnum>\n");
	printf("\texport <table> <filename>\n");
	printf("\n");
	printf("$Id$\n");
	exit(0);

}//void PrintUsage(char *arg0)


void ExtMainShell(int argc, char *argv[])
{
	if(argc==3)
	{
		if(!strcmp(argv[1],"ProcessJobQueue"))
		{
			MasterJobQueue(argv[2]);
		}
		else if(!strcmp(argv[1],"ProcessExtJobQueue"))
		{
			ProcessExtJobQueue(argv[2]);
			exit(0);
		}
		else if(!strcmp(argv[1],"installbind"))
		{
			InstallNamedFiles(argv[2]);
		}
		else if(!strcmp(argv[1],"Initialize"))
		{
			Initialize(argv[2]);
		}
		else if(!strcmp(argv[1],"Backup"))
		{
                	Backup(argv[2]);
			exit(0);
		}
        	else if(!strcmp(argv[1],"RestoreAll"))
		{
                	RestoreAll(argv[2]);
		}
		PrintUsage(argv[0]);
	}
	else if(argc==4)
	{
		if(!strcmp(argv[1],"jobqueue"))
		{
			if(!strcmp(argv[2],"master"))
				MasterJobQueue(argv[3]);
		}
		else if(!strcmp(argv[1],"export"))
		{
			ExportTable(argv[2],argv[3]);
		}
        	else if(!strcmp(argv[1],"Restore"))
		{
                	Restore(argv[2],argv[3]);
			exit(0);
		}
		PrintUsage(argv[0]);
	}
	else if(argc==5)
	{
		if(!strcmp(argv[1],"allfiles"))
		{
			if(!strcmp(argv[2],"slave"))
			{
				ConnectMysqlServer();
				CreateSlaveFiles(argv[3],"",argv[4]);//All

			}
			else if(!strcmp(argv[2],"master"))
			{
				ConnectDb();
				//All+DBFiles+Stubs
				CreateMasterFiles(argv[3],"",1,1);
			}
#ifdef BIND9
			system("/usr/sbin/rndc reload");
#else
			system("/usr/sbin/ndc -c /var/run/ndc-mysqlbind reload");
#endif
			exit(0);
		}
		else if(!strcmp(argv[1],"jobqueue"))
		{
			if(!strcmp(argv[2],"slave"))
				SlaveJobQueue(argv[3],argv[4]);
		}
		PrintUsage(argv[0]);
	}
	PrintUsage(argv[0]);


}//void ExtMainShell(int argc, char *argv[])


void Tutorial(void)
{
	Header_ism3("Tutorial",0);
	printf("</center><blockquote>");
	PassDirectHtml("mysqlbind.tutorial.txt");
	printf("</blockquote>");
	Footer_ism3();
}//void Tutorial(void)


void NamedConf(void)
{
	Header_ism3("NamedConf()",0);
	printf("</center><pre><blockquote>");
	PassDirectHtml("/usr/local/mysqlbind/named.conf");
	printf("</blockquote></pre>");
	Footer_ism3();
}//void NamedConf(void)


void Admin(void)
{
	Header_ism3("Admin",0);
	printf("<table width=900><tr><td>");
	printf("<form action=mysqlBind.cgi method=post>");
	printf("<font face=arial,helvetica size=1>");
	
	printf("<input type=hidden name=function value=MainTools>");
	printf("<input title='use dig to check all tNameServer nameserver sets via direct queries' class=largeButton type=submit name=command value=Status><br>");

	if(uPermLevel > 7 )
	{
		printf("<input title='View this systems named.conf file' class=largeButton type=submit name=command value=NamedConf><br>");
	}

	if(uPermLevel > 9 )
	{
		printf("<input title='Import zone data from existing named system' class=lwarnButton type=submit name=command value=Import><br>");
	}
	
	printf("</td></tr></table></form>");
	Footer_ism3();

}//void NamedConf(void)




void RestoreAll(char *cPasswd)
{
	char cISMROOT[256]={""};

	if(getenv("ISMROOT")!=NULL)
	{
		strncpy(cISMROOT,getenv("ISMROOT"),255);
		cHost[255]=0;
	}

	if(!cISMROOT[0])
	{
		printf("You must set ISMROOT env var first. Ex. (csh) setenv ISMROOT /home/ism-3.0\n");
	exit(1);
	}

	printf("Restoring mysqlBind data from .txt file in %s/{{cProject}}/data...\n\n",cISMROOT);

	//connect as root to master db
	mySQLRootConnect(cPasswd);

	sprintf(query,"use %s",DBNAME);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	for(i=0;cTableList[i][0];i++)
	{
sprintf(query,"load data infile '%s/mysqlBind/data/%s.txt' replace into table %s",cISMROOT,cTableList[i],cTableList[i]);
		mysql_query(&mysql,query);
		if(mysql_errno(&mysql))
		{
			printf("%s\n",mysql_error(&mysql));
			exit(1);
		}
		printf("%s\n",cTableList[i]);
	}

	printf("\nDone\n");

}//void RestoreAll(char *cPasswd)


void Restore(char *cPasswd, char *cTableName)
{
	char cISMROOT[256]={""};

	if(getenv("ISMROOT")!=NULL)
	{
		strncpy(cISMROOT,getenv("ISMROOT"),255);
		cHost[255]=0;
	}

	if(!cISMROOT[0])
	{
		printf("You must set ISMROOT env var first. Ex. (csh) setenv ISMROOT /home/ism-3.0\n");
	exit(1);
	}

	printf("Restoring mysqlBind data from .txt file in %s/{{cProject}}/data...\n\n",cISMROOT);

	//connect as root to master db
	mySQLRootConnect(cPasswd);

	sprintf(query,"use %s",DBNAME);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	sprintf(query,"load data infile '%s/mysqlBind/data/%s.txt' replace into table %s",cISMROOT,cTableName,cTableName);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	printf("%s\n\nDone\n",cTableName);

}//void Restore(char *cPasswd, char *cTableName)


void Backup(char *cPasswd)
{
	char cISMROOT[256]={""};

	if(getenv("ISMROOT")!=NULL)
	{
		strncpy(cISMROOT,getenv("ISMROOT"),255);
		cHost[255]=0;
	}

	if(!cISMROOT[0])
	{
		printf("You must set ISMROOT env var first. Ex. (csh) setenv ISMROOT /home/ism-3.0\n");
	exit(1);
	}

	printf("Backing up mysqlBind data to .txt files in \
%s/mysqlBind/data...\n\n",cISMROOT);

	//connect as root to master db
	mySQLRootConnect(cPasswd);

	sprintf(query,"use %s",DBNAME);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	for(i=0;cTableList[i][0];i++)
	{
		char cFileName[300];

		sprintf(cFileName,"%s/mysqlBind/data/%s.txt"
				,cISMROOT,cTableList[i]);
		unlink(cFileName);

sprintf(query,"SELECT * INTO OUTFILE '%s' FROM %s",cFileName,cTableList[i]);
		mysql_query(&mysql,query);
		if(mysql_errno(&mysql))
		{
			printf("%s\n",mysql_error(&mysql));
			exit(1);
		}
		printf("%s\n",cTableList[i]);
	}


	printf("\nDone.\n");

}//void Backup(char *cPasswd)


void Initialize(char *cPasswd)
{
	char cISMROOT[256]={""};
	char cCGIDIR[256]={""};
	time_t clock;

	if(getenv("ISMROOT")!=NULL)
	{
		strncpy(cISMROOT,getenv("ISMROOT"),255);
		cISMROOT[255]=0;
	}

	if(!cISMROOT[0])
	{
		printf("You must set ISMROOT env var first. Ex. (csh) setenv ISMROOT /home/joe\n");
		exit(1);
	}

	if(getenv("CGIDIR")!=NULL)
	{
		strncpy(cCGIDIR,getenv("CGIDIR"),255);
		cCGIDIR[255]=0;
	}

	if(!cCGIDIR[0])
	{
		printf("You must set CGIDIR env var first. Ex. (csh) setenv CGIDIR /admin/cgi-bin/ (Note the trailing /)\n");
		exit(1);
	}

	printf("Creating db and setting permissions, installing data from %s/mysqlBind...\n\n",cISMROOT);

	//connect as root to master db
	mySQLRootConnect(cPasswd);

	//Create database
	
	sprintf(query,"CREATE DATABASE %s",DBNAME);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	//Grant localaccess privileges.
	sprintf(query,"GRANT ALL ON %s.* to %s@localhost identified by '%s'",
			DBNAME,DBLOGIN,DBPASSWD);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}
	
	//Change to mysqlbind db. Then initialize some tables with needed data
	sprintf(query,"USE %s",DBNAME);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}
	
	
	time(&clock);
	
	CreatetAuthorize();
	//And 3 standard example users
	sprintf(query,"INSERT INTO tAuthorize SET cLabel='Root',uCertClient=1,cIpMask='0.0.0.0',uPerm=12,uOwner=1,uCreatedBy=1,uCreatedDate=%lu,cPasswd='..M0/uAvCFhis'",clock);
mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}
	sprintf(query,"INSERT INTO tAuthorize SET cLabel='Jane Admin',uCertClient=2,cIpMask='0.0.0.0',uPerm=10,uOwner=1,uCreatedBy=1,uCreatedDate=%lu,cPasswd='..M0/uAvCFhis'",clock);
mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}
	sprintf(query,"INSERT INTO tAuthorize SET cLabel='Joe Reseller',uCertClient=3,cIpMask='0.0.0.0',uPerm=8,uOwner=1,uCreatedBy=1,uCreatedDate=%lu,cPasswd='..M0/uAvCFhis'",clock);
mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	CreatetClient();
	sprintf(query,"INSERT INTO tClient SET cLabel='Root',uOwner=1,uCreatedBy=1,uCreatedDate=%lu",clock);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}
	sprintf(query,"INSERT INTO tClient SET cLabel='Jane Admin',uOwner=1,uCreatedBy=1,uCreatedDate=%lu",clock);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}
	sprintf(query,"INSERT INTO tClient SET cLabel='Joe Reseller',uOwner=1,uCreatedBy=1,uCreatedDate=%lu",clock);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql))
	{
		printf("%s\n",mysql_error(&mysql));
		exit(1);
	}

	//Create tables and install default data
	CreatetZone();
	CreatetResource();
	CreatetRRType();
	CreatetNameServer();
	CreatetJob();
	CreatetMailServer();
	CreatetConfiguration();

        for(i=0;cInitTableList[i][0];i++)
        {
                sprintf(query,"load data infile '%s/mysqlBind/data/%s.txt' replace into table %s",cISMROOT,cInitTableList[i],cInitTableList[i]);
                mysql_query(&mysql,query);
                if(mysql_errno(&mysql))
                {
                        printf("%s\n",mysql_error(&mysql));
                        exit(1);
                }
        }

        sprintf(query,"cp $ISMROOT/mysqlBind/docs/tutorial.html $CGIDIR/mysqlbind.tutorial.txt");
	system(query);

        printf("Done\n");
	exit(0);

}//void Initialize(void)


void mySQLRootConnect(char *cPasswd)
{
        mysql_init(&mysql);
        if (!mysql_real_connect(&mysql,NULL,"root",cPasswd,"mysql",0,NULL,0))
        {
                printf("Database server unavailable\n");
                exit(1);
        }
}//void mySQLRootConnect(void)

