/*
FILE
	tMailServer source code of mysqlBind.cgi
	(built by mysqlRAD2.cgi (c) Gary Wallis 2001,2002 GPL Licensed)
	$Id: tmailserver.c,v 1.13 2003/11/13 20:44:21 ggw Exp $
	(tAuthorize.cPasswd template set member)
PURPOSE
*/

#include "mysqlrad.h"

//Table Variables
//uMailServer: Primary Key
static unsigned uMailServer=0;
//cLabel: Group of mail servers label
static char cLabel[33]={""};
//cList: List of mail servers
static char *cList={""};
//uOwner: Record owner
static unsigned uOwner=0;
//uCreatedBy: uClient for last insert
static unsigned uCreatedBy=0;
#define ISM3FIELDS
//uCreatedDate: Unix seconds date last insert
static long unsigned uCreatedDate=0;
//uModBy: uClient for last update
static unsigned uModBy=0;
//uModDate: Unix seconds date last update
static long unsigned uModDate=0;




#define VAR_LIST_tMailServer "tMailServer.uMailServer,tMailServer.cLabel,tMailServer.cList,tMailServer.uOwner,tMailServer.uCreatedBy,tMailServer.uCreatedDate,tMailServer.uModBy,tMailServer.uModDate"

 //Local only
void Insert_tMailServer(void);
void Update_tMailServer(char *rowid);
int InsertUpdate_tMailServer(char *cKey);
void ProcesstMailServerListVars(pentry entries[], int x);

 //In tMailServerfunc.h file included below
void ExtProcesstMailServerVars(pentry entries[], int x);
void ExttMailServerCommands(pentry entries[], int x);
void ExttMailServerButtons(void);
void ExttMailServerNavBar(void);
void ExttMailServerGetHook(entry gentries[], int x);
void ExttMailServerSelect(void);
void ExttMailServerSelectRow(void);
void ExttMailServerListSelect(void);
void ExttMailServerListFilter(void);
void ExttMailServerAuxTable(void);

#include "tmailserverfunc.h"

 //Table Variables Assignment Function
void ProcesstMailServerVars(pentry entries[], int x)
{
	register int i;


	for(i=0;i<x;i++)
	{
		if(!strcmp(entries[i].name,"uMailServer"))
			sscanf(entries[i].val,"%u",&uMailServer);
		else if(!strcmp(entries[i].name,"cLabel"))
			sprintf(cLabel,"%.32s",entries[i].val);
		else if(!strcmp(entries[i].name,"cList"))
			cList=entries[i].val;
		else if(!strcmp(entries[i].name,"uOwner"))
			sscanf(entries[i].val,"%u",&uOwner);
		else if(!strcmp(entries[i].name,"uCreatedBy"))
			sscanf(entries[i].val,"%u",&uCreatedBy);
		else if(!strcmp(entries[i].name,"uCreatedDate"))
			sscanf(entries[i].val,"%lu",&uCreatedDate);
		else if(!strcmp(entries[i].name,"uModBy"))
			sscanf(entries[i].val,"%u",&uModBy);
		else if(!strcmp(entries[i].name,"uModDate"))
			sscanf(entries[i].val,"%lu",&uModDate);

	}

	//After so we can overwrite form data if needed.
	ExtProcesstMailServerVars(entries,x);

}//ProcesstMailServerVars()


void ProcesstMailServerListVars(pentry entries[], int x)
{
        register int i;

        for(i=0;i<x;i++)
        {
                if(!strncmp(entries[i].name,"ED",2))
                {
                        sscanf(entries[i].name+2,"%u",&uMailServer);
                        mode=6;
                        tMailServer("");
                }
        }
}//void ProcesstMailServerListVars(pentry entries[], int x)


int tMailServerCommands(pentry entries[], int x)
{
	ProcessControlVars(entries,x);

	ExttMailServerCommands(entries,x);

	if(!strcmp(function,"tMailServerTools"))
	{
		if(!strcmp(find,LANG_NB_LIST))
		{
			tMailServerList();
		}

		//Default
		ProcesstMailServerVars(entries,x);
		tMailServer("");
	}
	else if(!strcmp(function,"tMailServerList"))
	{
		ProcessControlVars(entries,x);
		ProcesstMailServerListVars(entries,x);
		tMailServerList();
	}

	return(0);

}//tMailServerCommands()


void tMailServer(char *result)
{
	MYSQL_RES *res;
	MYSQL_RES *res2;
	MYSQL_ROW field;

	//Internal skip reloading
	if(!result[0])
	{
		if(mode)
			ExttMailServerSelectRow();
		else
			ExttMailServerSelect();

		mysql_query(&mysql,query);
		if(mysql_errno(&mysql))
        	{
			if(strstr(mysql_error(&mysql)," doesn't exist"))
                	{
				CreatetMailServer();
				mysqlBind("New tMailServer table created");
                	}
			else
			{
				mysqlBind(mysql_error(&mysql));
			}
        	}

		res=mysql_store_result(&mysql);
		if((i=mysql_num_rows(res)))
		{
			if(mode==6)
			{
			sprintf(query,"SELECT _rowid FROM tMailServer WHERE uMailServer=%u"
						,uMailServer);
			mysql_query(&mysql,query);
			res2=mysql_store_result(&mysql);
			field=mysql_fetch_row(res2);
			sscanf(field[0],"%lu",&rowid);
			rowid++;
			}
			PageMachine("",0,"");
			if(!mode) mysql_data_seek(res,rowid-1);
			field=mysql_fetch_row(res);
		sscanf(field[0],"%u",&uMailServer);
		sprintf(cLabel,"%.32s",field[1]);
		cList=field[2];
		sscanf(field[3],"%u",&uOwner);
		sscanf(field[4],"%u",&uCreatedBy);
		sscanf(field[5],"%lu",&uCreatedDate);
		sscanf(field[6],"%u",&uModBy);
		sscanf(field[7],"%lu",&uModDate);

		}

	}//Internal Skip

	Header_ism3(":: tMailServer",0);
	printf("<form action=mysqlBind.cgi method=post >\n");
	printf("<table width=900 border=0 bgcolor=#A9BEC0 valign=center>\n");
	printf("<tr><td colspan=2><font face=Arial,Helvetica size=2>");


	ExttMailServerNavBar();

	printf("<input type=hidden name=function value=tMailServerTools>");
	printf("<input type=hidden name=rowid value=%lu>",rowid);
	if(i)
	{
		printf(" <font color=blue >");
		if(mode==6)
			//printf(" Found");
			printf(LANG_NBR_FOUND);
		else if(mode==5)
			//printf(" Modified");
			printf(LANG_NBR_MODIFIED);
		else if(mode==4)
			//printf(" New");
			printf(LANG_NBR_NEW);
		printf(LANG_NBRF_SHOWING,rowid,i);
	}
	else
	{
		if(!result[0])
		//printf(" No records found");
		printf(LANG_NBR_NORECS);
	}
	if(result[0]) printf(" <b> %s",result);
	printf("</td></tr>");
	printf("<tr><td valign=top>");

        ExttMailServerButtons();

        printf("</td><td valign=top>");
	printf("<table width=630 border=0 bgcolor=#9BC1B3 valign=center>\n");

	if(mode==2000 || mode==2002)
		tMailServerInputContent();
	else
		tMailServerContent();

	printf("</table>\n");
	printf("</table>\n");

	//Bottom table
        ExttMailServerAuxTable();

	printf("</font></form>\n");
	Footer_ism3();

}//end of tMailServer();


void tMailServerContent(void)
{

	OpenRow(LANG_FL_tMailServer_uMailServer,"white");
	printf("%u<input type=hidden name=uMailServer value=%u >\n",uMailServer,uMailServer);
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tMailServer_cLabel,"white");
	printf("%s<input type=hidden name=cLabel value=\"%s\">",cLabel,EncodeDoubleQuotes(cLabel));
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tMailServer_cList,"white");
	printf("<pre><font face=Arial,Helvetica>%s</pre>\n\n",
		TransformAngleBrackets(cList));
	printf("<input type=hidden name=cList value=\"%s\">",
		EncodeDoubleQuotes(cList));
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tMailServer_uOwner,"white");
	printf("%s<input type=hidden name=uOwner value=%u >\n",ForeignKey("tClient","cLabel",uOwner),uOwner);
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tMailServer_uCreatedBy,"white");
	printf("%s<input type=hidden name=uCreatedBy value=%u >\n",ForeignKey("tClient","cLabel",uCreatedBy),uCreatedBy);
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tMailServer_uCreatedDate,"white");
	if(uCreatedDate)
		printf("%s\n\n",ctime(&uCreatedDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uCreatedDate value=%lu >\n",uCreatedDate);
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tMailServer_uModBy,"white");
	printf("%s<input type=hidden name=uModBy value=%u >\n",ForeignKey("tClient","cLabel",uModBy),uModBy);
	printf("&nbsp;&nbsp;");
	OpenRow(LANG_FL_tMailServer_uModDate,"white");
	if(uModDate)
		printf("%s\n\n",ctime(&uModDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uModDate value=%lu >\n",uModDate);
	printf("&nbsp;&nbsp;");
	printf("</tr>\n");



}//tMailServerContent()


void tMailServerInputContent(void)
{

	OpenRow(LANG_FL_tMailServer_uMailServer,"white");
	if(uPermLevel>=20)
		printf("<input title='%s' type=text name=uMailServer value=%u size=16 maxlength=10>\n",LANG_FT_tMailServer_uMailServer,uMailServer);
	else
		printf("%u<input type=hidden name=uMailServer value=%u >\n",uMailServer,uMailServer);
	OpenRow(LANG_FL_tMailServer_cLabel,"white");
	printf("<input title='%s' type=text name=cLabel value=\"%s\" size=40 maxlength=32>\n",LANG_FT_tMailServer_cLabel,EncodeDoubleQuotes(cLabel));
	OpenRow(LANG_FL_tMailServer_cList,"white");
	printf("<textarea title='%s' cols=40 wrap=hard rows=3 name=cList>%s</textarea>\n\n",LANG_FT_tMailServer_cList,cList);
	OpenRow(LANG_FL_tMailServer_uOwner,"white");
	printf("%s<input type=hidden name=uOwner value=%u >\n",ForeignKey("tClient","cLabel",uOwner),uOwner);
	OpenRow(LANG_FL_tMailServer_uCreatedBy,"white");
	printf("%s<input type=hidden name=uCreatedBy value=%u >\n",ForeignKey("tClient","cLabel",uCreatedBy),uCreatedBy);
	OpenRow(LANG_FL_tMailServer_uCreatedDate,"white");
	if(uCreatedDate)
		printf("%s\n\n",ctime(&uCreatedDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uCreatedDate value=%lu >\n",uCreatedDate);
	OpenRow(LANG_FL_tMailServer_uModBy,"white");
	printf("%s<input type=hidden name=uModBy value=%u >\n",ForeignKey("tClient","cLabel",uModBy),uModBy);
	OpenRow(LANG_FL_tMailServer_uModDate,"white");
	if(uModDate)
		printf("%s\n\n",ctime(&uModDate));
	else
		printf("---\n\n");
	printf("<input type=hidden name=uModDate value=%lu >\n",uModDate);
	printf("</tr>\n");



}//void tMailServerInputContent(void)


void NewtMailServer(unsigned uMode)
{
	register int i=0;
	MYSQL_RES *res;

	//New select
	sprintf(query,"SELECT uMailServer FROM tMailServer\
				WHERE uMailServer=%u"
							,uMailServer);
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	if(i) 
		//tMailServer("<blink>Record already exists");
		tMailServer(LANG_NBR_RECEXISTS);

	//insert query
	Insert_tMailServer();
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	//sprintf(query,"New record %u added");
	uMailServer=mysql_insert_id(&mysql);

	if(!uMode)
	{
	sprintf(query,LANG_NBR_NEWRECADDED,uMailServer);
	tMailServer(query);
	}

}//NewtMailServer(unsigned uMode)


void DeletetMailServer(void)
{
#ifdef ISM3FIELDS
	sprintf(query,"DELETE FROM tMailServer WHERE uMailServer=%u AND ( uOwner=%u OR %u>9 )"
					,uMailServer,uLoginClient,uPermLevel);
#else
	sprintf(query,"DELETE FROM tMailServer WHERE uMailServer=%u"
					,uMailServer);
#endif
	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));

	//tMailServer("Record Deleted");
	if(mysql_affected_rows(&mysql)>0)
		tMailServer(LANG_NBR_RECDELETED);
	else
		tMailServer(LANG_NBR_RECNOTDELETED);

}//void DeletetMailServer(void)


void Insert_tMailServer(void)
{

#ifdef ISM3FIELDS
	time_t clock;

        time(&clock);
#endif

	//insert query

	//insert query
	sprintf(query,"INSERT INTO tMailServer SET  uMailServer=%u, cLabel='%s', cList='%s', uOwner=%u, uCreatedBy=%u, uCreatedDate=%lu, uModBy=%u, uModDate=0",
			uMailServer
			,TextAreaSave(cLabel)
			,TextAreaSave(cList)
			,uOwner
			,uCreatedBy
			,(long unsigned)clock
			,uModBy
			);


	mysql_query(&mysql,query);
#ifdef ISM3FIELDS
	uCreatedDate=clock;
#endif

}//void Insert_tMailServer(void)


void Update_tMailServer(char *rowid)
{
#ifdef ISM3FIELDS
	time_t clock;

        time(&clock);
#endif

	//update query

	//update query
	sprintf(query,"UPDATE tMailServer SET uMailServer=%u,cLabel='%s',cList='%s',uModBy=%u,uModDate=%lu WHERE _rowid=%s",
			uMailServer
			,TextAreaSave(cLabel)
			,TextAreaSave(cList)
			,uModBy
			,(long unsigned)clock
			,rowid);


	mysql_query(&mysql,query);

#ifdef ISM3FIELDS
	uModDate=clock;
#endif

}//void Update_tMailServer(void)


void ModtMailServer(void)
{
	register int i=0;
	MYSQL_RES *res;
	MYSQL_ROW field;
#ifdef ISM3FIELDS
	unsigned uPreModDate=0;

	//Mod select query
	if(uPermLevel<10)
	sprintf(query,"SELECT tMailServer.uMailServer,\
				tMailServer.uModDate\
				FROM tMailServer,tClient\
				WHERE tMailServer.uMailServer=%u\
				AND tMailServer.uOwner=tClient.uClient\
				AND (tClient.uOwner=%u OR tClient.uClient=%u)"
			,uMailServer,uLoginClient,uLoginClient);
	else
	sprintf(query,"SELECT uMailServer,uModDate FROM tMailServer\
				WHERE uMailServer=%u"
						,uMailServer);
#else
	sprintf(query,"SELECT uMailServer FROM tMailServer\
				WHERE uMailServer=%u"
						,uMailServer);
#endif

	mysql_query(&mysql,query);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	//if(i<1) tMailServer("<blink>Record does not exist");
	if(i<1) tMailServer(LANG_NBR_RECNOTEXIST);
	//if(i>1) tMailServer("<blink>Multiple rows!");
	if(i>1) tMailServer(LANG_NBR_MULTRECS);

	field=mysql_fetch_row(res);
#ifdef ISM3FIELDS
	sscanf(field[1],"%u",&uPreModDate);
	if(uPreModDate!=uModDate) tMailServer(LANG_NBR_EXTMOD);
#endif

	Update_tMailServer(field[0]);
	if(mysql_errno(&mysql)) mysqlBind(mysql_error(&mysql));
	//sprintf(query,"record %s modified",field[0]);
	sprintf(query,LANG_NBRF_REC_MODIFIED,field[0]);
	tMailServer(query);

}//ModtMailServer(void)


void tMailServerList(void)
{
	MYSQL_RES *res;
	MYSQL_ROW field;

	ExttMailServerListSelect();

	mysql_query(&mysql,query);
	if(mysql_error(&mysql)[0]) mysqlBind(mysql_error(&mysql));
	res=mysql_store_result(&mysql);
	i=mysql_num_rows(res);

	PageMachine("tMailServerList",1,"");//1 is auto header list mode. Opens table!

	//Filter select drop down
	ExttMailServerListFilter();

	printf("<input type=text size=16 name=command maxlength=98 value=\"%s\" >",command);

	printf("</table>\n");

	printf("<table bgcolor=#9BC1B3 border=0 width=900>\n");
	printf("<tr bgcolor=black><td><font face=arial,helvetica color=white>uMailServer<td><font face=arial,helvetica color=white>cLabel<td><font face=arial,helvetica color=white>cList<td><font face=arial,helvetica color=white>uOwner<td><font face=arial,helvetica color=white>uCreatedBy<td><font face=arial,helvetica color=white>uCreatedDate<td><font face=arial,helvetica color=white>uModBy<td><font face=arial,helvetica color=white>uModDate</tr>");



	mysql_data_seek(res,start-1);

	for(n=0;n<(end-start+1);n++)
	{
		field=mysql_fetch_row(res);
		if(!field)
		{
			printf("<tr><td><font face=arial,helvetica>End of data</table>");
			Footer_ism3();
		}
			if(n % 2)
				printf("<tr bgcolor=#BBE1D3>");
			else
				printf("<tr>");
		printf("<td><font face=arial,helvetica size=1><input type=submit name=ED%s value=Edit></font> %s<td>%s<td><pre><font face=Arial,Helvetica>%s<td>%s<td>%s<td>%s<td>%s<td>%s</tr>"
			,field[0]
			,field[0]
			,field[1]
			,field[2]
			,field[3]
			,field[4]
			,field[5]
			,field[6]
			,field[7]
				);

	}

	printf("</table></form>\n");
	Footer_ism3();

}//tMailServerList()


void CreatetMailServer(void)
{
	sprintf(query,"CREATE TABLE tMailServer ( uMailServer int unsigned NOT NULL DEFAULT 0 PRIMARY KEY AUTO_INCREMENT, cList text NOT NULL DEFAULT '', uOwner int unsigned NOT NULL DEFAULT 0,index (uOwner), uCreatedBy int unsigned NOT NULL DEFAULT 0, uCreatedDate int unsigned NOT NULL DEFAULT 0, uModBy int unsigned NOT NULL DEFAULT 0, uModDate int unsigned NOT NULL DEFAULT 0, cLabel varchar(32) NOT NULL DEFAULT '' )");
	mysql_query(&mysql,qstr);
	if(mysql_errno(&mysql))
		mysqlBind(mysql_error(&mysql));
}//CreatetMailServer()

